<?php
/*
	(C)2007 Dustin Spicuzza
	Simple script to generate webpage listing from items in a directory. This is designed
	to have a HTML template around it.
	
	The way it works: You have a lot of files in a directory, and they should all be
	named something like 
	
		product-version.extension
		product.version.extension
		product.extension
	
	So, you just need to add a text file (.txt) named [product].txt. The format of the file is:
	
		title
		URL to page describing download
		Short description
		... more description
		
	Enjoy! Send bugs to dustin@virtualroadside.com
	
*/
?><h4>Software Downloads</h4>
<p>Over the last couple of years, I've worked on countless small software projects and a few
bigger ones (mostly for work). Most of them are things that I've created for practical purposes, but others
are just silly little things.</p>
<p>This is a list of all the software that I have available for download here on the Virtual Roadside. All of the software is released under an open source license of some kind. Those that do not contain a license are released under the following terms:</p>
<p><a href="javascript:toggle_hidden('license')">Show License Terms</a></p>
<div style="display:none;font-family: courier;background: #efefef;padding:1em;" id="license">
Copyright (c) <?php echo date('Y');?>, Dustin Spicuzza<br/>
All rights reserved.<br/>
Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
<ul>
	<li>Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.</li>
	<li>Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.</li>
	<li>Neither the name of Dustin Spicuzza nor the names of any contributors may be used to endorse or promote products derived from this software without specific prior written permission.</li>
</ul>
THIS SOFTWARE IS PROVIDED BY DUSTIN SPICUZZA AND CONTRIBUTORS ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL DUSTIN SPICUZZA AND CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
</div>
<script type="text/javascript"><!--
function toggle_hidden(item){
	var hidden = document.getElementById(item);
	
	if (!hidden.style.display || hidden.style.display == "none")
		hidden.style.display = "block";
	else
		hidden.style.display = "none";
}
//--></script>
<style type="text/css">
table td{vertical-align: top;}
</style>
<?php

// both must end with a /
$directory = './download/';
$url = '##rootdir##/download/';

$descriptions = array();
$files = array();

if (is_dir($directory)) {
	if ($dh = opendir($directory)) {
		while (($file = readdir($dh)) !== false) {
			$path = pathinfo($file);
			if (isset($path['extension'])){
				if ($path['extension'] == 'txt'){
					$descriptions[] = substr($path['basename'],0,strlen($path['basename']) - strlen($path['extension']) - 1);
				}else if ($file != ".." && $file != "."){
					$product = get_product_name($file);
					
					if (!array_key_exists($product,$files)){
						$files[$product] = array();
						$files[$product]['files'] = array();
						$files[$product]['included'] = false;
					}
					
					$files[$product]['files'][] = $file;
				}
			}
		}
		closedir($dh);
		
		echo "<table>";
		
		// another loop, displaying results
		foreach ($descriptions as $file){
			$array = file($directory . $file . '.txt');
			if (count($array) > 2){
				echo "\t<tr><td colspan=\"2\"><strong>" . htmlentities($array[0]) . "</strong></td></tr>\n";
				echo "\t<tr><td>Description:</td><td>" . nl2br(htmlentities(implode('',array_splice($array,2)))) . "</td></tr>\n";
				echo "\t<tr><td>Link:</td><td><a href=\"" . htmlentities($array[1]) . "\">More information</a></td></tr>\n";
				
				// see if there are any files associated with it
				if (array_key_exists($file,$files)){
				
					$files[$file]['included'] = true;
					echo "\t<tr><td>Files:</td><td>";
					
					$j = 0;
					rsort($files[$file]['files']);
					foreach ($files[$file]['files'] as $dl){
						echo "<a href=\"" . $url . htmlentities($dl) . "\">" . htmlentities($dl) . "</a>";
						if ($j++ != count($files[$file]['files']) - 1)
							echo "<br/>";
					}
					
					echo "</td></tr>\n";
				}
				
				echo "\t<tr><td colspan=\"2\">&nbsp;</td></tr>\n";
			}
		}
		
		// final loop
		$found = false;
		foreach ($files as $file){
			if ($file['included'] == false){
				if ($found == false){
					$found = true;
					echo "\t<tr><td colspan=\"2\"><strong>Other Downloads</strong></td></tr>\n\t<tr><td colspan=\"2\">\n\t\t<ul>\n";
				}
				foreach ($file['files'] as $dl){
					echo "\t\t\t<li><a href=\"" . $url . htmlentities($dl) . "\">" . htmlentities($dl) . "</a></li>\n";
				}
			}
		}
		if ($found)
			echo "\t\t</ul></td>\n\t</tr>\n";
			
		echo "</table>";
    }
}

function get_product_name($file){
	// split by dash
	if (($d = strrpos($file,'-')) !== false){
		return substr($file,0,$d);
	}
	// split by period
	return substr($file,0,strpos($file,'.'));
}


?><p>This page is automatically generated. Let me know if there are any errors. Thanks!</p>